﻿@page "/todo"
@inject HttpClient Http
@inject CustomAuthenticationStateProvider AuthStateProvider
@inject IJSRuntime JS

<MudDropContainer T="TaskItem" @ref="_dropContainer" Class="d-flex flex-row flex-wrap">
	<ChildContent>
		@foreach (var _section in _sections)
		{
			<MudPaper Elevation="0" Width="320px" MinHeight="500px" Class="pa-4 ma-4 d-flex flex-column mud-background-gray rounded-lg">
				<MudToolBar DisableGutters="true">
					<MudText Typo="Typo.subtitle1"><b>@_section.Name</b></MudText>
					<MudSpacer />
					<MudMenu Icon="@Icons.Material.Rounded.MoreHoriz" AnchorOrigin="Origin.BottomRight" TransformOrigin="Origin.TopRight" ListClass="pa-2 d-flex flex-column" PopoverClass="mud-elevation-25">
						<MudButton Size="Size.Small" Color="Color.Default" @onclick="@(() => DeleteSection(_section))">
							<MudIcon Icon="@Icons.Material.Filled.DeleteForever" Color="Color.Error" />
							Delete List
						</MudButton>
					</MudMenu>
				</MudToolBar>
				<MudDropZone T="TaskItem" Identifier="@_section.Name" Class="mud-height-full">
					@foreach (var task in _section.getTaskItemModels)
					{
						<MudPaper Elevation="25" Class="d-flex pa-4 rounded-lg my-3 justify-space-between align-center">
							<div>@task.Name</div>
							<div><MudIcon Icon="@Icons.Material.Filled.DeleteForever" Color="Color.Error" Class="cursor-pointer" @onclick="@(() => DeleteTask(task))" /></div>
						</MudPaper>
					}
				</MudDropZone>
				@if (_section.NewTaskOpen)
				{
					<MudPaper Elevation="25" Class="pa-2 rounded-lg">
						<MudTextField @bind-Value="_section.NewTaskName" Placeholder="New Task" DisableUnderLine="true" Margin="Margin.Dense" Class="mx-2 mt-n2"></MudTextField>
						<MudButton OnClick="@(() => AddTask(_section.NewTaskName, _section.Id))" Size="Size.Small" Color="Color.Primary" FullWidth="true">Add Task</MudButton>
					</MudPaper>
				}
				else
				{
					<MudButton OnClick="@(() => _section.NewTaskOpen = !_section.NewTaskOpen)" StartIcon="@Icons.Material.Filled.Add" FullWidth="true" Class="rounded-lg py-2">Add Task</MudButton>
				}
			</MudPaper>
		}
		@if (_addSectionOpen)
		{
			<MudPaper Elevation="0" Width="320px" MinHeight="500px" Class="pa-4 ma-4 d-flex flex-column rounded-lg">
				<MudPaper Elevation="0" Width="224px" Class="pa-4 d-flex flex-column mud-background-gray rounded-lg">
					<EditForm Model="@newSectionModel" OnValidSubmit="OnValidSectionSubmit">
						<DataAnnotationsValidator />
						<MudTextField @bind-Value="newSectionModel.Name" Placeholder="New List" DisableUnderLine="true"></MudTextField>
						<MudButton OnClick="@(() => AddSection(newSectionModel.Name))" Size="Size.Small" Color="Color.Primary" FullWidth="true">Add List</MudButton>
					</EditForm>
				</MudPaper>
			</MudPaper>
		}
		else
		{
			<MudPaper Elevation="0" Width="320px" Class="pa-4 ma-4 d-flex flex-column rounded-lg" Style="background: inherit;">
				<MudButton OnClick="OpenAddNewSection" Variant="Variant.Outlined" StartIcon="@Icons.Material.Filled.Add" Color="Color.Primary" Class="rounded-lg py-2" FullWidth="true">Add List</MudButton>
			</MudPaper>
		}
	</ChildContent>
	<ItemRenderer>
		<MudPaper Elevation="25" Class="pa-4 rounded-lg my-3">@context.Name</MudPaper>
	</ItemRenderer>
</MudDropContainer>


@code {
	private MudDropContainer<TaskItem> _dropContainer;
	private bool _addSectionOpen;

	/* Setup for board  */
	private List<TaskSection> _sections = new List<TaskSection>();
	private List<TaskItem> _tasks;

	protected override async Task OnInitializedAsync()
	{
		await GetAllSections();
	}

	public async Task GetAllSections()
	{
		List<TaskSection> sections = new List<TaskSection>();
		var userId = await JS.InvokeAsync<string>("localStorage.getItem", "UserId");
		try
		{
			sections = await Http.GetFromJsonAsync<List<TaskSection>>($"api/TaskSections/{userId}");
			if (sections == null) _sections = new List<TaskSection>();
		}
		catch (Exception ex)
		{
			Console.WriteLine($"Error fetching task sections: {ex.Message}");
			_sections = new List<TaskSection>();
		}

		_sections = sections;
	}


	KanBanNewForm newSectionModel = new KanBanNewForm();

	public class KanBanNewForm
	{
		[Required]
		[StringLength(10, ErrorMessage = "Name length can't be more than 10.")]
		public string Name { get; set; }
	}

	private void OnValidSectionSubmit(EditContext context)
	{
		newSectionModel.Name = string.Empty;
		_addSectionOpen = false;
	}

	private void OpenAddNewSection()
	{
		_addSectionOpen = true;
	}

	public async Task AddTask(string taskName, Guid sectionId)
	{
		TaskItem newTask = new TaskItem
			{
				Name = taskName,
				TaskSectionId = sectionId
			};

		await AddTaskToApi(newTask);
		await GetAllSections();
	}

	private async Task AddTaskToApi(TaskItem task)
	{
		try
		{
			var response = await Http.PostAsJsonAsync("api/TaskItems", task);
			if (response.IsSuccessStatusCode)
			{
				Console.WriteLine("Task added successfully.");
			}
			else
			{
				Console.WriteLine($"Failed to add task. Status code: {response.StatusCode}");
			}
		}
		catch (Exception ex)
		{
			Console.WriteLine($"Exception thrown while adding task: {ex.Message}");
		}
	}

	private async Task DeleteTask(TaskItem task)
	{
		try
		{
			await Http.DeleteAsync($"api/TaskItems/{task.Id}");
			await GetAllSections();
		}
		catch (Exception ex)
		{
			Console.WriteLine($"Exception thrown while deleting task: {ex.Message}");
		}
	}

	public async Task AddSection(string sectionName)
	{

		var userId = await JS.InvokeAsync<string>("localStorage.getItem", "UserId");



		TaskSection newTaskSection = new TaskSection
			{
				Name = sectionName,
				UserId = Guid.Parse(userId)
			};

		await AddSectionToApi(newTaskSection);
		RenewAddSection();
		await GetAllSections();
	}

	private async Task AddSectionToApi(TaskSection taskSection)
	{
		try
		{
			var response = await Http.PostAsJsonAsync("api/TaskSections", taskSection);
			if (response.IsSuccessStatusCode)
			{
				Console.WriteLine("Task added successfully.");
			}
			else
			{
				Console.WriteLine($"Failed to add task. Status code: {response.StatusCode}");
			}
		}
		catch (Exception ex)
		{
			Console.WriteLine($"Exception thrown while adding task: {ex.Message}");
		}
	}

	private async Task DeleteSection(TaskSection taskSection)
	{
		try
		{
			await Http.DeleteAsync($"api/TaskSections/{taskSection.Id}");
			await GetAllSections();
		}
		catch (Exception ex)
		{
			Console.WriteLine($"Exception thrown while deleting task: {ex.Message}");
		}
	}

	private void RenewAddSection()
	{
		newSectionModel.Name = string.Empty;
		_addSectionOpen = false;
	}
}
